Solid Example: Atoms

import { render } from 'solid-js/web'
import { createAtom, useAtom, useSelector } from '@tanstack/solid-store'

// Optionally, you can create atoms outside of Solid components at module scope
const countAtom = createAtom(0)

function App() {
  return (
    <main>
      <h1>Solid Atom Hooks</h1>
      <p>
        This example creates a module-level atom and reads and updates it with
        the Solid hooks.
      </p>
      <AtomValuePanel />
      <AtomButtons />
      <AtomStepper />
    </main>
  )
}

function AtomValuePanel() {
  const count = useSelector(countAtom) // useSelector with no selector re-renders when the value changes. Useful for read-only access to an atom.

  return <p>Total: {count()}</p>
}

function AtomButtons() {
  return (
    <div>
      <button type="button" onClick={() => countAtom.set((prev) => prev + 1)}>
        Increment
      </button>
      <button type="button" onClick={() => countAtom.set(0)}>
        Reset
      </button>
    </div>
  )
}

function AtomStepper() {
  const [count, setCount] = useAtom(countAtom) // read and write access to the atom.

  return (
    <div>
      <p>Editable count: {count()}</p>
      <button type="button" onClick={() => setCount((prev) => prev + 5)}>
        Add 5 with useAtom
      </button>
    </div>
  )
}

render(() => <App />, document.getElementById('root')!)
import { render } from 'solid-js/web'
import { createAtom, useAtom, useSelector } from '@tanstack/solid-store'

// Optionally, you can create atoms outside of Solid components at module scope
const countAtom = createAtom(0)

function App() {
  return (
    <main>
      <h1>Solid Atom Hooks</h1>
      <p>
        This example creates a module-level atom and reads and updates it with
        the Solid hooks.
      </p>
      <AtomValuePanel />
      <AtomButtons />
      <AtomStepper />
    </main>
  )
}

function AtomValuePanel() {
  const count = useSelector(countAtom) // useSelector with no selector re-renders when the value changes. Useful for read-only access to an atom.

  return <p>Total: {count()}</p>
}

function AtomButtons() {
  return (
    <div>
      <button type="button" onClick={() => countAtom.set((prev) => prev + 1)}>
        Increment
      </button>
      <button type="button" onClick={() => countAtom.set(0)}>
        Reset
      </button>
    </div>
  )
}

function AtomStepper() {
  const [count, setCount] = useAtom(countAtom) // read and write access to the atom.

  return (
    <div>
      <p>Editable count: {count()}</p>
      <button type="button" onClick={() => setCount((prev) => prev + 5)}>
        Add 5 with useAtom
      </button>
    </div>
  )
}

render(() => <App />, document.getElementById('root')!)

React Example: Atoms

import ReactDOM from 'react-dom/client'
import {
  createAtom,
  useAtom,
  // useCreateAtom,
  useSelector,
} from '@tanstack/react-store'

// Optionally, you can create atoms outside of React components at module scope
const countAtom = createAtom(0)

function App() {
  // or define atoms inside of components with hook variant. You would have to pass atom as props or use store context though.
  // const countAtom = useCreateAtom(0)

  return (
    <main>
      <h1>React Atom Hooks</h1>
      <p>
        This example creates a module-level atom and reads and updates it with
        the React hooks.
      </p>
      <AtomValuePanel />
      <AtomButtons />
      <AtomStepper />
    </main>
  )
}

function AtomValuePanel() {
  const count = useSelector(countAtom) // useSelector with no selector re-renders when the value changes. Useful for read-only access to an atom.

  return <p>Total: {count}</p>
}

function AtomButtons() {
  return (
    <div>
      <button type="button" onClick={() => countAtom.set((prev) => prev + 1)}>
        Increment
      </button>
      <button type="button" onClick={() => countAtom.set(0)}>
        Reset
      </button>
    </div>
  )
}

function AtomStepper() {
  const [count, setCount] = useAtom(countAtom) // read and write access to the atom. Re-renders when the value changes.

  return (
    <div>
      <p>Editable count: {count}</p>
      <button type="button" onClick={() => setCount((prev) => prev + 5)}>
        Add 5 with useAtom
      </button>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(<App />)
import ReactDOM from 'react-dom/client'
import {
  createAtom,
  useAtom,
  // useCreateAtom,
  useSelector,
} from '@tanstack/react-store'

// Optionally, you can create atoms outside of React components at module scope
const countAtom = createAtom(0)

function App() {
  // or define atoms inside of components with hook variant. You would have to pass atom as props or use store context though.
  // const countAtom = useCreateAtom(0)

  return (
    <main>
      <h1>React Atom Hooks</h1>
      <p>
        This example creates a module-level atom and reads and updates it with
        the React hooks.
      </p>
      <AtomValuePanel />
      <AtomButtons />
      <AtomStepper />
    </main>
  )
}

function AtomValuePanel() {
  const count = useSelector(countAtom) // useSelector with no selector re-renders when the value changes. Useful for read-only access to an atom.

  return <p>Total: {count}</p>
}

function AtomButtons() {
  return (
    <div>
      <button type="button" onClick={() => countAtom.set((prev) => prev + 1)}>
        Increment
      </button>
      <button type="button" onClick={() => countAtom.set(0)}>
        Reset
      </button>
    </div>
  )
}

function AtomStepper() {
  const [count, setCount] = useAtom(countAtom) // read and write access to the atom. Re-renders when the value changes.

  return (
    <div>
      <p>Editable count: {count}</p>
      <button type="button" onClick={() => setCount((prev) => prev + 5)}>
        Add 5 with useAtom
      </button>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(<App />)

Angular Example: Atoms

import { Component } from '@angular/core'
import { createAtom, injectAtom } from '@tanstack/angular-store'

// Optionally, you can create atoms outside of Angular components at module scope
const countAtom = createAtom(0)

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <main>
      <h1>Angular Atom Hooks</h1>
      <p>
        This example creates a module-level atom and reads and updates it with
        the Angular hooks.
      </p>
      <p>Count: {{ count() }}</p>
      <div>
        <button type="button" (click)="count.set((prev) => prev + 1)">
          Increment
        </button>
        <button type="button" (click)="count.set(0)">Reset</button>
      </div>
      <div>
        <button type="button" (click)="count.set((prev) => prev + 5)">
          Add 5
        </button>
      </div>
    </main>
  `,
})
export class AppComponent {
  count = injectAtom(countAtom)
}
import { Component } from '@angular/core'
import { createAtom, injectAtom } from '@tanstack/angular-store'

// Optionally, you can create atoms outside of Angular components at module scope
const countAtom = createAtom(0)

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <main>
      <h1>Angular Atom Hooks</h1>
      <p>
        This example creates a module-level atom and reads and updates it with
        the Angular hooks.
      </p>
      <p>Count: {{ count() }}</p>
      <div>
        <button type="button" (click)="count.set((prev) => prev + 1)">
          Increment
        </button>
        <button type="button" (click)="count.set(0)">Reset</button>
      </div>
      <div>
        <button type="button" (click)="count.set((prev) => prev + 5)">
          Add 5
        </button>
      </div>
    </main>
  `,
})
export class AppComponent {
  count = injectAtom(countAtom)
}

<script setup lang="ts">
import { createAtom, useAtom, useSelector } from '@tanstack/vue-store'

// Optionally, you can create atoms outside of Vue components at module scope
const countAtom = createAtom(0)

const count = useSelector(countAtom) // useSelector with no selector re-renders when the value changes. Useful for read-only access to an atom.
const [editableCount, setEditableCount] = useAtom(countAtom) // read and write access to the atom. Re-renders when the value changes.
</script>

<template>
  <main>
    <h1>Vue Atom Hooks</h1>
    <p>
      This example creates a module-level atom and reads and updates it with the
      Vue hooks.
    </p>
    <p>Total: {{ count }}</p>
    <div>
      <button type="button" @click="countAtom.set((prev: number) => prev + 1)">
        Increment
      </button>
      <button type="button" @click="countAtom.set(0)">Reset</button>
    </div>
    <div>
      <p>Editable count: {{ editableCount }}</p>
      <button
        type="button"
        @click="setEditableCount((prev: number) => prev + 5)"
      >
        Add 5 with useAtom
      </button>
    </div>
  </main>
</template>
<script setup lang="ts">
import { createAtom, useAtom, useSelector } from '@tanstack/vue-store'

// Optionally, you can create atoms outside of Vue components at module scope
const countAtom = createAtom(0)

const count = useSelector(countAtom) // useSelector with no selector re-renders when the value changes. Useful for read-only access to an atom.
const [editableCount, setEditableCount] = useAtom(countAtom) // read and write access to the atom. Re-renders when the value changes.
</script>

<template>
  <main>
    <h1>Vue Atom Hooks</h1>
    <p>
      This example creates a module-level atom and reads and updates it with the
      Vue hooks.
    </p>
    <p>Total: {{ count }}</p>
    <div>
      <button type="button" @click="countAtom.set((prev: number) => prev + 1)">
        Increment
      </button>
      <button type="button" @click="countAtom.set(0)">Reset</button>
    </div>
    <div>
      <p>Editable count: {{ editableCount }}</p>
      <button
        type="button"
        @click="setEditableCount((prev: number) => prev + 5)"
      >
        Add 5 with useAtom
      </button>
    </div>
  </main>
</template>